Distribution:	CCux
Packager:  	Karsten Brockmann <arcam@ccux-linux.de>
Summary:   	Fortran77 subroutines designed to solve large scale eigenvalue problems.
Name:      	arpack
Version:   	96
Release:   	3
License: 	Freely distributable
URL:		http://www.caam.rice.edu/software/ARPACK/
Group:     	Development/Libraries
Source0: 	%{name}%{version}.tar.gz
Source1:	patch.tar.gz
Patch0:		%{name}-2.1-redhat.patch
Patch1:		arpack-etime-gfortran.patch
BuildRoot: 	%{_tmppath}/%{name}-buildroot
BuildRequires:	gcc-gfortran
#BuildRequires:  glibc-devel

%description
The package is designed to compute a few eigenvalues and corresponding eigenvectors of a general n by n matrix A. It is most appropriate for large sparse or structured matrices A where structured means that a matrix-vector product w <- Av requires order n rather than the usual order n2 floating point operations. This software is based upon an algorithmic variant of the Arnoldi process called the Implicitly Restarted Arnoldi Method (IRAM). When the matrix A is symmetric it reduces to a variant of the Lanczos process called the Implicitly Restarted Lanczos Method (IRLM). These variants may be viewed as a synthesis of the Arnoldi/Lanczos process with the Implicitly Shifted QR technique that is suitable for large scale problems. For many standard problems, a matrix factorization is not required. Only the action of the matrix on a vector is needed. 
 ARPACK software is capable of solving large scale symmetric, nonsymmetric, and generalized eigenproblems from significant application areas. The software is designed to compute a few (k) eigenvalues with user specified features such as those of largest real part or largest magnitude. Storage requirements are on the order of n*k locations. No auxiliary storage is required. A set of Schur basis vectors for the desired k-dimensional eigen-space is computed which is numerically orthogonal to working precision. Numerically accurate eigenvectors are available on request. 

%package        devel
Summary:        header files for %{name}
Group:          System/Libraries
Requires:       %{name} = %{version}-%{release}

%description devel
header files for %{name}


%post
ldconfig

%postun
ldconfig

%prep
%setup -q -b 1 -n ARPACK
%patch -p1 -b .rh
%patch1
mkdir static shared

%build
cd shared
for dir in ../SRC ../UTIL; do
  make -f $dir/Makefile VPATH=$dir srcdir=$dir \
       FC=gfortran FFLAGS="${CFLAGS} -fPIC" \
       single double complex complex16
done
gcc -shared -Wl,-soname,libarpack.so.2 -o libarpack.so.2.1 *.o
cd ..
cd static
for dir in ../SRC ../UTIL; do
  make -f $dir/Makefile VPATH=$dir srcdir=$dir \
  FC=gfortran FFLAGS="${CFLAGS}" LDFLAGS="-s" \
       all
done
ar rv libarpack.a *.o
ranlib libarpack.a
cd ..

%install
rm -rf %{buildroot}
mkdir -p %{buildroot}%{_libdir}
install -p -m644 static/libarpack.a %{buildroot}%{_libdir}
install -p -m755 shared/libarpack.so.2.1 %{buildroot}%{_libdir}
ln -s libarpack.so.2.1 %{buildroot}%{_libdir}/libarpack.so.2
ln -s libarpack.so.2 %{buildroot}%{_libdir}/libarpack.so


%files
%defattr(-,root,root,-)
%{_libdir}/libarpack.so.*

%files devel
%defattr(-,root,root,-)
%doc DOCUMENTS EXAMPLES
%{_libdir}/libarpack.so
%{_libdir}/libarpack.a

%clean
rm -rf $RPM_BUILD_ROOT

%changelog
* Mon Aug 06 2007 Stefan Gottwald <gotti@ccux-linux.de> 96-3
- switched to compilation with gcc-gfortran
* Mon May 21 2007 Karsten Brockmann <arcam@ccux-linux.de> 96-2
- switched to compilation with gcc-g77
* Tue Jan 16 2007 Karsten Brockmann <arcam@ccux-linux.de> 96-1
- Initial Release
